package com.adamatomic.Mode
{
	import flash.filters.DisplacementMapFilter;
	import org.flixel.*;

	public class PlayState extends FlxState
	{
		[Embed(source="../../../data/gibs.png")] private var ImgGibs:Class;
		[Embed(source="../../../data/spawner_gibs.png")] private var ImgSpawnerGibs:Class;
	
		public static var basespeed:Number;

		public static var _em:FlxEmitter;
		public static var _em2:FlxEmitter;
		
		//major game objects
		protected var _bullets:FlxGroup;

		//HUD
		public static var _healthLbl:FlxText;
		protected var _timeleftLbl:FlxText;
		protected var _leveltxt:FlxText;
		
		private var _endtype:String;
		public static var health:int;
		public static var timeleft:Number;

		private var _fading:Boolean;
		
		private var _labels:Array;
		public static var _timein:Number;

		private function AddBullet(n:int, vel:Number):void
		{
			var b:Bullet = new Bullet(n, vel);
			_bullets.add(b);
		}

		private var levels:Array = 
		[
		// [health,speed, level length, [key,relative speed]]
		[2,70, 7, [4, 1]],
		[2,50, 10, [4, 1], [7,2]],
		[2,50, 10, [4, 1], [7,2],[8,1]],
		[5,80, 10, [4, 1],[7,4/3]],
		[5,100, 10, [4, 5/4],[7,1]],
		[5, 100, 10, [4, 5 / 4], [7, 3 / 4]],
		[10,70, 10, [3,1],[4, 1.05], [7,1.1]],
		[5, 100, 10, [4, 1], [7, 2 ]],
		[10,70, 10, [3,1],[4, 1.1], [7,1.2]],
		[10,50, 10, [3,2],[4, 1], [7,2],[8,1],[9,2]],
		[10,20, 15, [3,1.25],[4, 1.8], [7,0.6],[8,1.1]],
		[10,70, 10, [3,1],[4, 1.1], [7,1.2],[8,1.3]],
		[10,50,15, [1,1], [4,1], [7,1],[0,1],[2,2],[3,2],[8,0.5],[8,0.5]],
		[10, 70, 10, [3, 1], [4, 1.2], [7, 1.4], [8, 1.8]],
		[10,70, 15, [2,1],[3,1.05],[4, 1.1], [7,1.15],[8,1.2],[9,1.25]]	,
		[10,20, 15, [1,1.5],[2,1],[3,1.25],[4, 1.8], [7,0.6],[8,1.1],[9,0.65],[0,1.3]],
		[10,70, 15, [1,0.95],[2,1],[3,1.05],[4, 1.1], [7,1.15],[8,1.2],[9,1.25],[0,1.3]],
		];
		
		public function startLevel():void 
		{		
			_timein = 0;
			if (FlxG.level >= levels.length)
			{
				FlxG.state = new VictoryState();
				return;
			}
			
			for (var i:int = 0; i < 10; i++)
			{
				_labels[i].visible = false;
			}
			
			for (i = _bullets.members.length-1; i >= 0; i--)
			{
				_bullets.remove(_bullets.members[i]);
			}
			
			health = levels[FlxG.level][0];
			basespeed = levels[FlxG.level][1];
			timeleft = levels[FlxG.level][2];
			for (i = 3; i < levels[FlxG.level].length; i++)
			{
				AddBullet(levels[FlxG.level][i][0], levels[FlxG.level][i][1]);
				_labels[levels[FlxG.level][i][0]].visible = true;
			}
			_fading = false;
		}
		
		public function resetLevel():void 
		{
			startLevel();
		}
		public function nextLevel():void
		{
			FlxG.level++;
			FlxG.flash.start(0xffffff,1,null,true);
			startLevel();
		}
		
		public function updateLbls():void
		{
			_timeleftLbl.text = "time: " + int(PlayState.timeleft);
			_healthLbl.text = "health: " + PlayState.health;
			_leveltxt.text = "level " + FlxG.level;
		}
		
		override public function create():void
		{
			
			
			FlxG.playMusic(MenuState.SndGame);
			
			FlxG.level = 0;
			FlxG.mouse.hide();
			add( new FlxSprite(0, 0, MenuState.ImgBackground));
			
			var gibs:FlxEmitter = new FlxEmitter(0,-50);
			gibs.setSize(FlxG.width,0);
			gibs.setXSpeed();
			gibs.setYSpeed(0,100);
			gibs.setRotation(-360,360);
			gibs.gravity = 80;
			gibs.createSprites(VictoryState.ImgGibs,50,32);
			add(gibs);
			gibs.start(false,0.2);
			
			
			
			_em = new FlxEmitter(0, 0);
			_em.width = 0;
			_em.height = 0;
			_em.createSprites(MenuState.ImgParticles, 50, 0);
			_em.acceleration.x = 0;
			_em.acceleration.y = 0;
			_em.angularAcceleration = 0;
			_em.setXSpeed(-100,100);
			_em.setYSpeed(-100,100);
			_em.setRotation(0, 0);
			_em.angle = 0;
			add(_em);
			
			
			_em2 = new FlxEmitter(0, 0);
			_em2.width = 0;
			_em2.height = 0;
			_em2.createSprites(MenuState.ImgParticles2, 50, 0);
			_em2.acceleration.x = 0;
			_em2.acceleration.y = 0;
			_em2.angularAcceleration = 0;
			_em2.setXSpeed(-100,100);
			_em2.setYSpeed(-100,100);
			_em2.setRotation(0, 0);
			_em2.angle = 0;
			add(_em2);
			
			
			_bullets = new FlxGroup();
			add(_bullets);
			
			_labels = new Array();
			
			_timeleftLbl = new FlxText(0, 0, FlxG.width);
			_timeleftLbl.color = 0xffffffff;
			_timeleftLbl.alignment = "right";
			add(_timeleftLbl);
			
			_leveltxt = new FlxText(0, 0, FlxG.width);
			_leveltxt.color = 0xffffffff;
			_leveltxt.alignment = "center";
			add(_leveltxt);
			
			_healthLbl = new FlxText(0, 0, FlxG.width);
			_healthLbl.color = 0xffffffff;
			_healthLbl.alignment = "left";
			add(_healthLbl);
			
			updateLbls();
			
			for (var i:int = 0; i < 10; i++)
			{
				var b:Bullet = new Bullet(i,4);
				var t:FlxText = new FlxText(b.x-1, FlxG.height / 2 - 10, 16, i.toString());
				t.alignment = "center";
				t.visible = false;
				_labels.push(t);
				this.add(t);				
			}

						
			FlxG.playMusic(MenuState.SndGame);
			FlxG.flash.start(0xff131c1b);
			_fading = false;			
			
			startLevel();
		}

		override public function update():void
		{
			var os:uint = FlxG.score;
			_timein += FlxG.elapsed;
			
			if (!_fading)
			{
				updateLbls();
	
				if (health <= 0)
				{
					FlxG.quake.start();
					_fading = true;
					_endtype = "DEAD";
					FlxG.fade.start(0xff000000, 1, onStuff, true);
				}
				else
				{
					timeleft -= FlxG.elapsed;
					if (timeleft <= 0)
					{
						timeleft = 0;
						nextLevel();
					}
				}
			}
			
			super.update();
		}

		protected function overlapped(Object1:FlxObject,Object2:FlxObject):void
		{
			if((Object1 is BotBullet) || (Object1 is Bullet))
				Object1.kill();
			Object2.hurt(1);
		}
		
		protected function onStuff():void
		{
			switch (_endtype)
			{
				case "DEAD":
				resetLevel();
				FlxG.fade.start(0x00000000, 0.1, null, true);
				break;
			}
		}
		
		protected function onVictory():void
		{
			FlxG.music.stop();
			FlxG.state = new VictoryState();
		}
	}
}
